<!--
  ************** Mail Any ideas/comments to info@cool.co.za ******************
-->
<%
 Function NumDays(dtSelected)
    '******* Function accepts a date and returns the number of days in a month
    
     datetime   = dateadd("d", -datepart("d",dtSelected)+1,dtSelected)
     datetime   = dateadd("m", 1, datetime)
     datetime   = dateadd("d", -1, datetime) 
     NumDays    = datepart("d",datetime)     
     
 end function

Function daySuff( byVal intDay )
 '******** Accepts a day of the month as an integer and returns the appropriate suffix
 Dim strOrd

 Select Case intDay
 Case 1, 21, 31
  strOrd = "st"
 Case 2, 22
  strOrd = "nd"
 Case 3, 23
  strOrd = "rd"
 Case Else
  strOrd = "th"
 End Select

 daySuff = strOrd
End Function ' daySuff

%>
<html>
<head>
<title>Tree Calendar View</title>
<link rel="stylesheet" href="sitestyle.css" type="text/css">
<style>
<!--
#liname
{
cursor:hand ;
list-style-image:url(./images/root.gif)
}
#monthfolditem
{list-style-image:none;
}
//-->
</style>
<script language="javascript1.2">
<!--
var head="display:''"
img1=new Image()
img1.src="url(./images/root.gif)"
img2=new Image()
img2.src="(./images/fold_o.gif)"

function change(){
   if(!document.all)
      return
   if (event.srcElement.id=="liname") {
      var srcIndex = event.srcElement.sourceIndex
      var nested = document.all[srcIndex+1]
      if (nested.style.display=="none") {
         nested.style.display=''
         event.srcElement.style.listStyleImage="url(./images/fold_o.gif)"
      }
      else {
         nested.style.display="none"
         event.srcElement.style.listStyleImage="url(./images/root.gif)"
      }
   }
}

document.onclick=change


//-->
</script>
</head>
<%
  
Sub DrawCalendar (numYears,blnBackWards)
   '*****************************************************
   '*							*
   '* Procedure accepts number of years 0 = Current	*
   '* blnBackWards = whether to go back in years or not	*
   '*							*
   '*****************************************************
  
  'The folding list items markup
  
   strheadel1   = "<li id='liname'>"
   strheadel2   = "</li>"
   strfoldlist2 = "<ul id='monthfolditem' style='display:none' style=&{head};>" 
   
  'check to see if we are starting from a negative value
   if blnBackWards then
     startYear = -Cint(numYears)
    else
     startYear = 0
   end if   

 for k = startYear to (numYears)
    dtyear = year(dateadd("yyyy",k,date))
    response.write strheadel1 &dtyear &strheadel2
    response.write strfoldlist2      
   for i = 1 to 12 
     dtdate = dateserial(dtyear,i,1)
     strdate =  month(i)
     intdays =  numdays(dtdate) 
     response.write strheadel1 &monthname(datepart("m",dtdate)) &strheadel2
     response.write strfoldlist2 
     for j = 1 to intdays
       response.write "<li><A HREF='showday.asp?date="&dtdate&"'>" &weekdayname(weekday(dtDate))&" - " &monthname(datepart("m",dtdate)) &"&nbsp;" &j &daySuff(j) &"</A></li>"
       dtDate = dateAdd("d",1,dtDate)
     next
     response.write "</ul>"
   next
   response.write "</ul>"
 next  
end Sub
  
  intDraw =  Request.Form("YEARS")
  
  Select case intDraw
  Case "0"   DrawCalendar 0,FALSE
  Case "1"   DrawCalendar 4,FALSE   
  Case "2"   DrawCalendar 4,TRUE   
  Case "3"   DrawCalendar 7,TRUE   
  Case Else  DrawCalendar 2,FALSE
  End Select 
 %>  
 
 <FORM ACTION="tree_calendar.asp" METHOD=POST>
 <SELECT NAME=YEARS>
 <OPTION VALUE=0>Current Year (DrawCalendar 0,FALSE)
 <OPTION VALUE=1>From 2001-2005 (DrawCalendar 4,FALSE)
 <OPTION VALUE=2>From 1997-2005 (DrawCalendar 4,TRUE)
 <OPTION VALUE=3>From 1994-2008 (DrawCalendar 7,TRUE)
 <INPUT TYPE=SUBMIT VALUE=SUBMIT>
 </FORM>
 <A HREF="source.zip">Source Code</A>
 </body>
</html>